package dev.boyfailure.quajra.vectorbreakout;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import javax.swing.JFrame;
import javax.swing.Timer;

public class VectorBreakout {
    
    public static String gameName = "Vector Breakout";
    public static boolean isPaused = false;
    public static boolean debugMenuEnabled = false;
    public static boolean isLost = false;
    public static short gameResX = 800;
    public static short gameResY = 600;
    public static byte lives = 5;
    public static byte chancey = 0;
    public static short level = 1;
    public static byte ballsOnScreen = 0;
    public static byte bricksOnScreen = 76;
    public static byte targetFrameRate = 60;
    public static byte actualFrames = 0;
    public static byte actualFrameRate = 0;
    public static byte gameTickRate = 60;
    public static int score = 0;
    public static long frameCounter = 0;
    public static boolean movingLeft = false;
    public static boolean movingRight = false;
    public static Ball[] currentBalls = {null,null,null,null,null};
    public static Paddle[] currentPaddles = {new Paddle(350, 500, 100, 15, 0, 1)};
    public static Brick[] currentBricks = {
        new Brick(20, 50, false, 0, 32, 0),
        new Brick(60, 50, false, 0, 32, 0),
        new Brick(100, 50, false, 0, 32, 0),
        new Brick(140, 50, false, 0, 32, 0),
        new Brick(180, 50, false, 0, 32, 0),
        new Brick(220, 50, false, 0, 32, 0),
        new Brick(260, 50, false, 0, 32, 0),
        new Brick(300, 50, false, 0, 32, 0),
        new Brick(340, 50, false, 0, 32, 0),
        new Brick(380, 50, false, 0, 32, 0),
        new Brick(420, 50, false, 0, 32, 0),
        new Brick(460, 50, false, 0, 32, 0),
        new Brick(500, 50, false, 0, 32, 0),
        new Brick(540, 50, false, 0, 32, 0),
        new Brick(580, 50, false, 0, 32, 0),
        new Brick(620, 50, false, 0, 32, 0),
        new Brick(660, 50, false, 0, 32, 0),
        new Brick(700, 50, false, 0, 32, 0),
        new Brick(740, 50, false, 0, 32, 0),
        new Brick(20, 70, false, 1, 16, 0),
        new Brick(60, 70, false, 1, 16, 0),
        new Brick(100, 70, false, 1, 16, 0),
        new Brick(140, 70, false, 1, 16, 0),
        new Brick(180, 70, false, 1, 16, 0),
        new Brick(220, 70, false, 1, 16, 0),
        new Brick(260, 70, false, 1, 16, 0),
        new Brick(300, 70, false, 1, 16, 0),
        new Brick(340, 70, false, 1, 16, 0),
        new Brick(380, 70, false, 1, 16, 0),
        new Brick(420, 70, false, 1, 16, 0),
        new Brick(460, 70, false, 1, 16, 0),
        new Brick(500, 70, false, 1, 16, 0),
        new Brick(540, 70, false, 1, 16, 0),
        new Brick(580, 70, false, 1, 16, 0),
        new Brick(620, 70, false, 1, 16, 0),
        new Brick(660, 70, false, 1, 16, 0),
        new Brick(700, 70, false, 1, 16, 0),
        new Brick(740, 70, false, 1, 16, 0),
        new Brick(20, 90, false, 2, 8, 0),
        new Brick(60, 90, false, 2, 8, 0),
        new Brick(100, 90, false, 2, 8, 0),
        new Brick(140, 90, false, 2, 8, 0),
        new Brick(180, 90, false, 2, 8, 0),
        new Brick(220, 90, false, 4, 8, 2),
        new Brick(260, 90, false, 2, 8, 0),
        new Brick(300, 90, false, 2, 8, 0),
        new Brick(340, 90, false, 2, 8, 0),
        new Brick(380, 90, false, 2, 8, 0),
        new Brick(420, 90, false, 2, 8, 0),
        new Brick(460, 90, false, 2, 8, 0),
        new Brick(500, 90, false, 2, 8, 0),
        new Brick(540, 90, false, 4, 8, 2),
        new Brick(580, 90, false, 2, 8, 0),
        new Brick(620, 90, false, 2, 8, 0),
        new Brick(660, 90, false, 2, 8, 0),
        new Brick(700, 90, false, 2, 8, 0),
        new Brick(740, 90, false, 2, 8, 0),
        new Brick(20, 110, false, 3, 4, 0),
        new Brick(60, 110, false, 3, 4, 0),
        new Brick(100, 110, false, 3, 4, 0),
        new Brick(140, 110, false, 3, 4, 0),
        new Brick(180, 110, false, 3, 4, 0),
        new Brick(220, 110, false, 3, 4, 0),
        new Brick(260, 110, false, 3, 4, 0),
        new Brick(300, 110, false, 3, 4, 0),
        new Brick(340, 110, false, 3, 4, 0),
        new Brick(380, 110, false, 3, 4, 0),
        new Brick(420, 110, false, 3, 4, 0),
        new Brick(460, 110, false, 3, 4, 0),
        new Brick(500, 110, false, 3, 4, 0),
        new Brick(540, 110, false, 3, 4, 0),
        new Brick(580, 110, false, 3, 4, 0),
        new Brick(620, 110, false, 3, 4, 0),
        new Brick(660, 110, false, 3, 4, 0),
        new Brick(700, 110, false, 3, 4, 0),
        new Brick(740, 110, false, 3, 4, 0)
    };

    public VectorBreakout() {
    }
    
    public static void main(String[] args) {
        final JFrame gameFrame = new JFrame();
        
        gameFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        gameFrame.setTitle(gameName);
        gameFrame.setSize(gameResX, gameResY);
        gameFrame.getContentPane().setBackground(Color.black);
        
        final GameDisplay gameCanvas = new GameDisplay();
        gameFrame.getContentPane().add(gameCanvas);
        
        gameFrame.setVisible(true);
        
        gameFrame.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                switch(e.getKeyCode()) {
                    case 27: // Escape
                        debugMenuEnabled = !debugMenuEnabled;
                        break;
                    case 10: // Enter
                        isPaused = !isPaused;
                        break;
                    case 32: // Space
                        if (isLost) {newGame();return;}
                        if (!isPaused) {
                            if (ballsOnScreen < 1) {
                                for (byte i = 0; i < currentBalls.length; i++) {
                                    if (currentBalls[i] == null) {
                                        currentBalls[i] = new Ball(200, 300, 7, 7, 0, true);
                                        currentBalls[i].spawnBall(true);
                                        return;
                                    }
                                }
                            }
                        }
                        break;
                    case 37: // Left
                        movingLeft = true;
                        break;
                    case 39: // Right
                        movingRight = true;
                        break;
                }
            }
            public void keyReleased(KeyEvent e) {
                switch(e.getKeyCode()) {
                    case 37: // Left
                        movingLeft = false;
                        break;
                    case 39: // Right
                        movingRight = false;
                        break;
                }
            }
            public void keyTyped(KeyEvent e) {}
        });
        
        // Adapts vector drawing scale when the window is resized 
        gameFrame.addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent componentEvent) {
                gameCanvas.beamScaleX = gameFrame.getBounds().width / 800f;
                gameCanvas.beamScaleY = gameFrame.getBounds().height / 600f;
            }
        });
        
        Timer gameTick = new Timer((1000 / gameTickRate), new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                onGameTick();
            }
        });
        gameTick.start();
        
        Timer frameDisplay = new Timer((1000 / targetFrameRate), new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                frameCounter++;
                gameFrame.repaint();
            }
        });
        frameDisplay.start();

        Timer gameCuller = new Timer(1000, new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                actualFrameRate = actualFrames;
                actualFrames = 0;
                for (byte i = 0; i < VectorBreakout.currentBricks.length; i++) {
                    if (VectorBreakout.currentBricks[i] != null) {
                        if (VectorBreakout.currentBricks[i].isBroken) {
                            VectorBreakout.currentBricks[i] = null;
                        }
                    }
                }
                for (byte i = 0; i < VectorBreakout.currentBalls.length; i++) {
                    if (VectorBreakout.currentBalls[i] != null) {
                        if (VectorBreakout.currentBalls[i].isActive == false) {
                            VectorBreakout.currentBalls[i] = null;
                        }
                    }
                }
                if (bricksOnScreen <= 0) {
                    refreshBricks();
                    if (level < 32767) {level++;} else {level = 1;}
                    if (lives < 127) {lives++;} else {lives = 127;}
                }
            }
        });
        gameCuller.start();
    }
    
    
    public static void onGameTick() {
        // i will implement something better than "chancey" eventually
        chancey++;
        if (chancey >= 16) {
            chancey = 0;
        }
        
        if (isPaused) {return;}
        
        // Move player if keys are held
        for (byte i = 0; i < currentPaddles.length; i++) {
            if (currentPaddles[i] != null) {
                if (movingLeft) {
                    currentPaddles[i].movePaddle(false);
                }
                else if (movingRight) {
                    currentPaddles[i].movePaddle(true);
                }
                else {
                    currentPaddles[i].paddleSpeed = 0;
                }
            }
        }
        
        // Ball logic (movement, collision checks)
        for (byte i = 0; i < currentBalls.length; i++) {
            if (currentBalls[i] != null) {
                if (currentBalls[i].isActive) {
                    currentBalls[i].moveBall();
                }
            }
        }   
    }
    
    
    public static void gameLose() {
        for (byte i = 0; i < currentBricks.length; i++) {
            currentBricks[i] = null;
        }
        for (byte i = 0; i < currentBalls.length; i++) {
            currentBalls[i] = null;
        }
        isLost = true;
        ballsOnScreen = 0;
    }
    
    public static void newGame() {
        lives = 5;
        isLost = false;
        score = 0;
        level = 1;
        frameCounter = 0;
        ballsOnScreen = 0;
        movingLeft = false;
        movingRight = false;
        currentPaddles[0] = new Paddle(350, 500, 100, 15, 0, 1);
        refreshBricks();
    }
    
    public static void refreshBricks() {
        bricksOnScreen = 76;
        currentBricks[0] = new Brick(20, 50, false, 0, 32, 0);currentBricks[1] = new Brick(60, 50, false, 0, 32, 0);currentBricks[2] = new Brick(100, 50, false, 0, 32, 0);currentBricks[3] = new Brick(140, 50, false, 0, 32, 0);currentBricks[4] = new Brick(180, 50, false, 0, 32, 0);currentBricks[5] = new Brick(220, 50, false, 0, 32, 0);currentBricks[6] = new Brick(260, 50, false, 0, 32, 0);currentBricks[7] = new Brick(300, 50, false, 0, 32, 0);currentBricks[8] = new Brick(340, 50, false, 0, 32, 0);currentBricks[9] = new Brick(380, 50, false, 0, 32, 0);currentBricks[10] = new Brick(420, 50, false, 0, 32, 0);currentBricks[11] = new Brick(460, 50, false, 0, 32, 0);currentBricks[12] = new Brick(500, 50, false, 0, 32, 0);currentBricks[13] = new Brick(540, 50, false, 0, 32, 0);currentBricks[14] = new Brick(580, 50, false, 0, 32, 0);currentBricks[15] = new Brick(620, 50, false, 0, 32, 0);currentBricks[16] = new Brick(660, 50, false, 0, 32, 0);currentBricks[17] = new Brick(700, 50, false, 0, 32, 0);currentBricks[18] = new Brick(740, 50, false, 0, 32, 0);currentBricks[19] = new Brick(20, 70, false, 1, 16, 0);currentBricks[20] = new Brick(60, 70, false, 1, 16, 0);currentBricks[21] = new Brick(100, 70, false, 1, 16, 0);currentBricks[22] = new Brick(140, 70, false, 1, 16, 0);currentBricks[23] = new Brick(180, 70, false, 1, 16, 0);currentBricks[24] = new Brick(220, 70, false, 1, 16, 0);currentBricks[25] = new Brick(260, 70, false, 1, 16, 0);currentBricks[26] = new Brick(300, 70, false, 1, 16, 0);currentBricks[27] = new Brick(340, 70, false, 1, 16, 0);currentBricks[28] = new Brick(380, 70, false, 1, 16, 0);currentBricks[29] = new Brick(420, 70, false, 1, 16, 0);currentBricks[30] = new Brick(460, 70, false, 1, 16, 0);currentBricks[31] = new Brick(500, 70, false, 1, 16, 0);currentBricks[32] = new Brick(540, 70, false, 1, 16, 0);currentBricks[33] = new Brick(580, 70, false, 1, 16, 0);currentBricks[34] = new Brick(620, 70, false, 1, 16, 0);currentBricks[35] = new Brick(660, 70, false, 1, 16, 0);currentBricks[36] = new Brick(700, 70, false, 1, 16, 0);currentBricks[37] = new Brick(740, 70, false, 1, 16, 0);currentBricks[38] = new Brick(20, 90, false, 2, 8, 0);currentBricks[39] = new Brick(60, 90, false, 2, 8, 0);currentBricks[40] = new Brick(100, 90, false, 2, 8, 0);currentBricks[41] = new Brick(140, 90, false, 2, 8, 0);currentBricks[42] = new Brick(180, 90, false, 2, 8, 0);currentBricks[43] = new Brick(220, 90, false, 4, 8, 2);currentBricks[44] = new Brick(260, 90, false, 2, 8, 0);currentBricks[45] = new Brick(300, 90, false, 2, 8, 0);currentBricks[46] = new Brick(340, 90, false, 2, 8, 0);currentBricks[47] = new Brick(380, 90, false, 2, 8, 0);currentBricks[48] = new Brick(420, 90, false, 2, 8, 0);currentBricks[49] = new Brick(460, 90, false, 2, 8, 0);currentBricks[50] = new Brick(500, 90, false, 2, 8, 0);currentBricks[51] = new Brick(540, 90, false, 4, 8, 2);currentBricks[52] = new Brick(580, 90, false, 2, 8, 0);currentBricks[53] = new Brick(620, 90, false, 2, 8, 0);currentBricks[54] = new Brick(660, 90, false, 2, 8, 0);currentBricks[55] = new Brick(700, 90, false, 2, 8, 0);currentBricks[56] = new Brick(740, 90, false, 2, 8, 0);currentBricks[57] = new Brick(20, 110, false, 3, 4, 0);currentBricks[58] = new Brick(60, 110, false, 3, 4, 0);currentBricks[59] = new Brick(100, 110, false, 3, 4, 0);currentBricks[60] = new Brick(140, 110, false, 3, 4, 0);currentBricks[61] = new Brick(180, 110, false, 3, 4, 0);currentBricks[62] = new Brick(220, 110, false, 3, 4, 0);currentBricks[63] = new Brick(260, 110, false, 3, 4, 0);currentBricks[64] = new Brick(300, 110, false, 3, 4, 0);currentBricks[65] = new Brick(340, 110, false, 3, 4, 0);currentBricks[66] = new Brick(380, 110, false, 3, 4, 0);currentBricks[67] = new Brick(420, 110, false, 3, 4, 0);currentBricks[68] = new Brick(460, 110, false, 3, 4, 0);currentBricks[69] = new Brick(500, 110, false, 3, 4, 0);currentBricks[70] = new Brick(540, 110, false, 3, 4, 0);currentBricks[71] = new Brick(580, 110, false, 3, 4, 0);currentBricks[72] = new Brick(620, 110, false, 3, 4, 0);currentBricks[73] = new Brick(660, 110, false, 3, 4, 0);currentBricks[74] = new Brick(700, 110, false, 3, 4, 0);currentBricks[75] = new Brick(740, 110, false, 3, 4, 0);
    }
}
